import { system, world } from '@minecraft/server';

const guardianMusicDisc = [
    'wed:record_guardian'
];

const hauntedmansionMusicDisc = [
    'wed:record_haunted_mansion'
];

const theendMusicDisc = [
    'wed:record_the_end'
];

const finalstageMusicDisc = [
    'wed:record_final_stage'
];

const theenderdragonMusicDisc = [
    'wed:record_the_ender_dragon'
];

const bonuslevelMusicDisc = [
    'wed:record_bonus_level'
];

const shulkerMusicDisc = [
    'wed:record_shulker'
];

const vanishedMusicDisc = [
    'wed:record_vanished'
];

const diamondcaveMusicDisc = [
    'wed:record_diamond_cave'
];

const allforoneMusicDisc = [
    'wed:record_all_for_one'
];

const breezeMusicDisc = [
    'wed:record_breeze'
];

const noescapeMusicDisc = [
    'wed:record_no_escape'
];

const beginningMusicDisc = [
    'wed:record_beginning'
];

const lasthallwayMusicDisc = [
    'wed:record_last_hallway'
];

const celebrationMusicDisc = [
    'wed:record_celebration'
];

const whisperingwoodsMusicDisc = [
    'wed:record_whispering_woods'
];

world.beforeEvents.playerInteractWithBlock.subscribe(evd => {
    const { player, itemStack, block } = evd;

    // This returns if the interacted block is not a Jukebox
    if (!block.permutation.matches('minecraft:jukebox')) return;

    if (itemStack) {
        if (theendMusicDisc.includes(itemStack.typeId)) {
            system.run(function () {
                block.dimension.playSound("record.the_end", block.location)
                player.runCommand(`title @a[r=10] actionbar §dNow playing: Laudividni - The end`)
            })
            return;
        }
        if (hauntedmansionMusicDisc.includes(itemStack.typeId)) {
            system.run(function () {
                block.dimension.playSound("record.haunted_mansion", block.location)
                player.runCommand(`title @a[r=10] actionbar §dNow playing: Laudividni - Haunted mansion`)
            })
            return;
        }
        if (theenderdragonMusicDisc.includes(itemStack.typeId)) {
            system.run(function () {
                block.dimension.playSound("record.the_ender_dragon", block.location)
                player.runCommand(`title @a[r=10] actionbar §dNow playing: T_en_M - The ender dragon`)
            })
            return;
        }
        if (finalstageMusicDisc.includes(itemStack.typeId)) {
            system.run(function () {
                block.dimension.playSound("record.final_stage", block.location)
                player.runCommand(`title @a[r=10] actionbar §dNow playing: Laudividni - Final stage`)
            })
            return;
        }
        if (bonuslevelMusicDisc.includes(itemStack.typeId)) {
            system.run(function () {
                block.dimension.playSound("record.bonus_level", block.location)
                player.runCommand(`title @a[r=10] actionbar §dNow playing: Laudividni & T_en_M - Bonus level`)
            })
            return;
        }
        if (shulkerMusicDisc.includes(itemStack.typeId)) {
            system.run(function () {
                block.dimension.playSound("record.shulker", block.location)
                player.runCommand(`title @a[r=10] actionbar §dNow playing: T_en_M - Shulker`)
            })
            return;
        }
        if (vanishedMusicDisc.includes(itemStack.typeId)) {
            system.run(function () {
                block.dimension.playSound("record.vanished", block.location)
                player.runCommand(`title @a[r=10] actionbar §dNow playing: Laudividni - Vanished`)
            })
            return;
        }
        if (diamondcaveMusicDisc.includes(itemStack.typeId)) {
            system.run(function () {
                block.dimension.playSound("record.diamond_cave", block.location)
                player.runCommand(`title @a[r=10] actionbar §dNow playing: Laudividni - Diamond Cave`);
            })
            return;
        }
        if (guardianMusicDisc.includes(itemStack.typeId)) {
            system.run(function () {
                block.dimension.playSound("record.guardian", block.location)
                player.runCommand(`title @a[r=10] actionbar §dNow playing: T_en_M - Guardian`);
            })
            return;
        }
        if (allforoneMusicDisc.includes(itemStack.typeId)) {
            system.run(function () {
                block.dimension.playSound("record.all_for_one", block.location)
                player.runCommand(`title @a[r=10] actionbar §dNow playing: Laudividni - All for one`);
            })
            return;
        }
        if (breezeMusicDisc.includes(itemStack.typeId)) {
            system.run(function () {
                block.dimension.playSound("record.breeze", block.location)
                player.runCommand(`title @a[r=10] actionbar §dNow playing: T_en_M - Breeze`);
            })
            return;
        }
        if (noescapeMusicDisc.includes(itemStack.typeId)) {
            system.run(function () {
                block.dimension.playSound("record.no_escape", block.location)
                player.runCommand(`title @a[r=10] actionbar §dNow playing: T_en_M & Laudividni - No escape`);
            })
            return;
        }
        if (beginningMusicDisc.includes(itemStack.typeId)) {
            system.run(function () {
                block.dimension.playSound("record.beginning", block.location)
                player.runCommand(`title @a[r=10] actionbar §dNow playing: Laudividni - Beginning`);
            })
            return;
        }
        if (lasthallwayMusicDisc.includes(itemStack.typeId)) {
            system.run(function () {
                block.dimension.playSound("record.last_hallway", block.location)
                player.runCommand(`title @a[r=10] actionbar §dNow playing: Laudividni - Last hallway`);
            })
            return;
        }
        if (celebrationMusicDisc.includes(itemStack.typeId)) {
            system.run(function () {
                block.dimension.playSound("record.celebration", block.location)
                player.runCommand(`title @a[r=10] actionbar §dNow playing: Laudividni & T_en_M - celebration`);
            })
            return;
        }
        if (whisperingwoodsMusicDisc.includes(itemStack.typeId)) {
            system.run(function () {
                block.dimension.playSound("record.whispering_woods", block.location)
                player.runCommand(`title @a[r=10] actionbar §dNow playing: Laudividni - Whispering woods`);
            })
            return;
        }
    }
    system.run(function () {
        player.runCommand(`stopsound @a record.guardian`);
        player.runCommand(`stopsound @a record.all_for_one`);
        player.runCommand(`stopsound @a record.breeze`);
        player.runCommand(`stopsound @a record.no_escape`);
        player.runCommand(`stopsound @a record.beginning`);
        player.runCommand(`stopsound @a record.last_hallway`);
        player.runCommand(`stopsound @a record.celebration`);
        player.runCommand(`stopsound @a record.whispering_woods`);
        player.runCommand(`stopsound @a record.diamond_cave`);
        player.runCommand(`stopsound @a record.vanished`);
        player.runCommand(`stopsound @a record.shulker`);
        player.runCommand(`stopsound @a record.bonus_level`);
        player.runCommand(`stopsound @a record.final_stage`);
        player.runCommand(`stopsound @a record.the_end`);
        player.runCommand(`stopsound @a record.the_ender_dragon`);
        player.runCommand(`stopsound @a record.haunted_mansion`)
    })
})
